//completare questo template defininendo i tipi e le funzioni richieste
//(operazioni base per simulare una partita a scacchi)
//non modificare le parti già definite

package main

import (
	"fmt"
)


//alias dei tipi che rappresentano colori e tipo dei pezzi
type (
	Colore bool
	Tipo   byte
)

//costanti simboliche usate per il Colore dei pezzi (al posto di true,false)
const (
	BIANCO = false
	NERO   = true
)

//enumerazione di costanti simboliche (1..6) che identificano il Tipo dei pezzi
//rispetta l'ordine in cui i corrispondenti simboli grafici compaiono nella tabella Unicode
const (
	NULL    = iota
	RE      // 1
	REGINA  // 2
	TORRE   // 3
	ALFIERE // ..
	CAVALLO
	PEDONE
)

// valore Unicode del "re bianco", il primo della sequenza dei pezzi
// i valori dei pezzi sono contigui, prima i bianchi poi i neri
const REBIANCO = 0x2654

// ***** Esercizio 1 *****

//definire i seguenti tipi:
//Pezzo - un pezzo è definito da un tipo e da un colore, ad es., {RE BIANCO}
//Casella - una casella è definita da una riga (int), compresa tra 1..8, e da una colonna (rune), compresa tra 'a'..'h'
//Scacchiera - una scacchiera è una associazione di caselle e pezzi

//definire le seguenti funzioni
// checkPezzo - verifica che il tipo di un pezzo sia corretto
func checkPezzo(p Pezzo) bool 

// StringPezzo - restituisce una stringa contenente il simbolo grafico di un determinato pezzo
// se il pezzo non è valido restituisce la stringa vuota
func StringPezzo(p Pezzo) string 

// checkCasella - verifica che le coordinate di una casella siano corrette
func checkCasella(c Casella) bool 

// get - ritorna il pezzo che si trova in una certa casella di una scacchiera,
// ed un valore booleano che indica se la casella è occupata (true) o vuota (false)
// nel caso di casella vuota, il pezzo ritornato è arbitrario
func get(s Scacchiera, c Casella) (Pezzo, bool)

// put - dispone un pezzo su una certa casella di una scacchiera
// controllando che sia il pezzo sia la casella siano validi
// nel caso non lo siano entrambi, non fa nulla e restituisce false
// altrimenti restituisce true
func put(s Scacchiera, p Pezzo, c Casella) bool 

// remove - svuota una certa casella di una scacchiera (senza eseguire controlli)
func remove(s Scacchiera, c Casella)

// ReadMove - legge una mossa da standard input, nella forma:
// riga1 colonna1 riga2 colonna2
// e restituisce le corrispondenti caselle, non eseguendo controlli
// esempio di input
// 2 a 3 a
func ReadMove() (Casella, Casella)


// ***** Esercizio 2 *****
//definire le seguenti funzioni

// CheckSrcDest - controlla che sulla casella di partenza (c1) di una scacchiera (che si assume definita correttamente)
// vi sia un pezzo di colore corrispondente al turno specificato, e che la casella di arrivo (c2) sia vuota,
// oppure ospiti un pezzo di colore diverso dal pezzo che muove
// in tal caso ritorna una tripla di valori (pezzos,pezzod,true), dove pezzos è il pezzo in c1,
// e pezzod è il pezzo in c2, se presente, oppure Pezzo{}, qualora c2 sia vuota
// se incece la condzione di cui sopra non è valida, ritorna una tripla (pezzos,pezzod,false), con pezzos e pezzod arbitrari
func CheckSrcDest(s Scacchiera, turno Colore, c1, c2 Casella) (Pezzo, Pezzo, bool)


//CreaScacchiera - crea e inizializza una scacchiera, disponendovi i pezzi nelle loro tradizionali posizioni iniziali
func CreaScacchiera() Scacchiera) 	



// ***** Esercizio 3 *****
//definire la seguente funzione
// checkAlfiere - verifica che un alfiere possa muoversi dalla casella c1 alla casella c2 di una scacchiera
// senza fare controlli sui pezzi presenti nelle caselle di arrivo/partenza, ma verificando invece che
// non siano presenti eventuali pezzi nelle caselle intermedie
func CheckAlfiere(s Scacchiera, c1, c2 Casella) bool


// ***** Esercizio 4 *****
//definire la seguente funzione
// checkCavallo - verifica che un cavallo possa muoversi dalla casella c1 alla casella c2 (di una ipotetica scacchiera)
func CheckCavallo(c1, c2 Casella) bool